## org.jfree.data
Interface KeyedValues

All Superinterfaces:
  Values

All Known Subinterfaces:
  KeyedValuesDataset, PieDataset

All Known Implementing Classes:
  CategoryToPieDataset, DefaultKeyedValues, DefaultKeyedValuesDataset, DefaultPieDataset, JDBCPieDataset

    public interface KeyedValues

extends Values

An ordered list of (key, value) items where the keys are unique and non-`null`.

See Also:
  `Values`, `DefaultKeyedValues`

Method Summary
`int` `getIndex(java.lang.Comparable key)` Returns the index for a given key.
`java.lang.Comparable` `getKey(int index)` Returns the key associated with the item at a given position.
`java.util.List` `getKeys()` Returns the keys for the values in the collection.
`java.lang.Number` `getValue(java.lang.Comparable key)` Returns the value for a given key.

Methods inherited from interface org.jfree.data.Values
`getItemCount, getValue`

Method Detail

### getKey

    java.lang.Comparable getKey(int index)

  Returns the key associated with the item at a given position. Note that some implementations allow re-ordering of the data items, so the result may be transient.

  Parameters:
    `index` - the item index (in the range `0` to `getItemCount() - 1`).
  Returns:
    The key (never `null`).
  Throws:
    `java.lang.IndexOutOfBoundsException` - if `index` is not in the specified range.

### getIndex

    int getIndex(java.lang.Comparable key)

  Returns the index for a given key.

  Parameters:
    `key` - the key (`null` not permitted).
  Returns:
    The index, or `-1` if the key is unrecognised.
  Throws:
    `java.lang.IllegalArgumentException` - if `key` is `null`.

### getKeys

    java.util.List getKeys()

  Returns the keys for the values in the collection. Note that you can access the values in this collection by key or by index. For this reason, the key order is important - this method should return the keys in order. The returned list may be unmodifiable.

  Returns:
    The keys (never `null`).

### getValue

    java.lang.Number getValue(java.lang.Comparable key)

  Returns the value for a given key.

  Parameters:
    `key` - the key.
  Returns:
    The value (possibly `null`).
  Throws:
    `UnknownKeyException` - if the key is not recognised.